class Cursor{ // osutab kohale skeemtekstis
    static final int BORDER  = -1;
    static final int COMMENT =  0;
    static final int HEAD    =  1;
    static final int BODY    =  2;
    
    Scheme scheme; // peremees-skeem (la"him)
    
    boolean inScheme; // true - millises skeemi osas
    // BORDER  - skeemil
    // COMMENT - skeemikommentaaril
    // HEAD    - lihtpa"isel
    // BODY    - lihtliikmel
    
    // kui section != BORDER ja section != COMMENT
    Primitive primitive; // peremees-primitiiv 
			 // null, kui skeemikommentaaril vo~i skeemi aa"rel
    Text text; // peremees-tekst; null, kui kommentaaril
    // kui section != BORDER:
    Row row; // teksti rida; ka teksti kommentaar ja skeemikomentaar
	     // null, kui skeemi aa"rel
    int noInRow; // reaelemendi number, mille ees (ka skeemikommentaaris) 
    
    boolean inScheme(){ // kas on mo~nel real, ka kommentaaril
		      // false, kui skeemi aa"rel
	return row != null;
    }// inScheme
    
    boolean inPrimitive(){ // kas on mo~nel primitiivil
			 // false, kui skeemikommentaaril
	return primitive != null;
    }// inPrimitive
    
    boolean inSchemeComment(){ // kas on skeemikommentaaril
	return inScheme() && !inPrimitive();
    }//	inSchemeComment
    
    boolean inHead(){ // kas on pa"ises
	return inPrimitive() && (primitive instanceof PrimitiveHead);
    }// inHead
    
    boolean inBody(){ // kas on kehas
	return inPrimitive() && (primitive instanceof PrimitiveMember);
    }// inBody
    
    boolean inTextComment(){ // kas on tekstikommentaaril
	return inPrimitive() && (text == null);
    }// inTextComment
    
    void moveToParentHome(){ // minna peremees-skeemi kommentaari algusse
	inScheme = true;
	primitive = null;
	text = null;
	row = scheme.comment;
	noInRow = 0;
    }// moveHome
    
    boolean moveToHead(){ // minna peremees-skeemi pa"isesse
	if(scheme.head.size() == 0) return false;
	inScheme = true;
	primitive = scheme.primitiveHead(0);
	text = primitive.text;
	row = text.row(0);
	noInRow = 0;
	return true;
    }// moveToHead
    
    boolean moveToBody(){ // minna peremees-skeemi kehasse 
			  // (kui keha pole tyhi)
    	Object o;
	int n = scheme.body.size();
	if(n == 0) return false;
	o = scheme.member(0);
	if(o instanceof Scheme){
	    scheme = (Scheme)o;
	    moveToParentHome();
	    return true;
	}
	// on primitiiv
	inScheme = true;
	primitive = (PrimitiveMember)o;
	text = primitive.text;
	row = text.row(0);
	noInRow = 0;
	return true;
    }// moveToBody
    
    boolean moveToNextMember(){ 
    // minna peremees-skeemile ja"rgnevale liikmele ylemuses
	Scheme father = scheme.parent;
	if(father == null) return false;
	int i = father.body.indexOf(scheme) + 1;
	if(i < father.body.size()){ // jrgm liige on olemas
	    Object o = father.member(i);
	    if(o instanceof Scheme){
		scheme = (Scheme)o;
		moveToParentHome();
		return true;
	    }
	    // on primitiiv
	    inScheme = true;
	    primitive = (PrimitiveMember)o;
	    text = primitive.text;
	    row = text.row(0);
	    noInRow = 0;
	    return true;
	}// jrgm liige on olemas
	else{ // jrgm liiget pole
	    scheme = father;
	    return moveToNextMember();
	}
    }// moveToNextMember
    
    boolean moveToNextElement(){// jrgm lihtpa"isele vo~i liikmele (kui on)
	int i, n;
	if(inHead()){
	    n = scheme.head.size();
	    i = scheme.head.indexOf(primitive) + 1;
	    if(i == n) return false;
	    primitive = scheme.primitiveHead(i);
	    text = primitive.text;
	    row = text.row(0);
	    noInRow = 0;
	    return true;
	}
	if(inBody()){
	    n = scheme.body.size();
	    i = scheme.body.indexOf(primitive) + 1;
	    if(i == n) return false;
	    Object o = scheme.member(i);
	    if(o instanceof Scheme){
		scheme = (Scheme)o;
		moveToParentHome();
		return true;
	    }
	    // on primitiiv
	    inScheme = true;
	    primitive = (PrimitiveMember)o;
	    text = primitive.text;
	    row = text.row(0);
	    noInRow = 0;
	    return true;
	   
	} 
	return false;
    }//  moveToNextElement
    
    boolean moveToNextRow(){// jrgm reale teksis (kui on)
	int i, n;
	n = text.rows.size();
	i = text.rows.indexOf(row) + 1;
	if(i == n) return false;
        row = text.row(i);
	noInRow = 0;
	return true;
    }// moveToNextRow 
     
    void moveToTextComment(){// teksti kommentaarile
        row = text.comment;
	noInRow = 0;
    }// moveToTextComment
    
    boolean moveDown(){
	if(!inScheme()){ 
	    moveToParentHome();
	    return true;
	}
	if(inSchemeComment()){
	    if(moveToHead()) return true;
	    if(moveToBody()) return true;
	    if(moveToNextMember()) return true;
	    return false;
	}
	if(inTextComment()){
	    if(moveToNextElement()) return true;
	    if(inHead()){
		if(moveToBody()) return true;
		if(moveToNextMember()) return true;
		return false;
	    }
	    if(moveToNextMember()) return true;
	    return false;
	}
	if(moveToNextRow())return true;
	moveToTextComment();
	return true;
    }// moveDown
}