import java.util.*; // siit klass Vector

abstract class Scheme{		// Sketch ja Branch ylemklass
    byte type;			// skeemi tyyp
    Vector head;		// lihtpa"ised
    Vector body;		// lihtliikmed, alamskeemid ja harud
    BaseLanguage baseLanguage;  // baaskeel
    View view;			// vaade
    Row comment;		// kommentaar
    Scheme parent;		// ylemus
    
    Scheme(byte t, BaseLanguage bl, View v){ // konstruktor
	type = t; head = new Vector(); body = new Vector();
	baseLanguage = bl; view = v; comment = new Row();
    }
    
    Object member(int i){   
	return body.elementAt(i);
    }
    
    // meetodid lihtpa"istega
    PrimitiveHead primitiveHead(int i){ // i-s lihtpa"is
	return (PrimitiveHead)(head.elementAt(i));
    }
    void insert(PrimitiveHead h, int i){ // lisada i-ndaks
	head.insertElementAt(h, i);
    }
    void removePrimitiveHead(int i){ // eemaldada i-s
	head.removeElementAt(i);
    }
    
    // meetodid liikmetega
    abstract void insert(PrimitiveMember pm, int i); // lisada lihtliige
    abstract void insert(Sketch sk, int i); // lisada alamskeem
    abstract void insert(Branch br, int i); // lisada haru
    abstract void removeMember(int i); // eemaldada i-s liige
    
    // taseme leidmine
    abstract int level();
     
}
